#ident	"$Header: /disk2/cvsroot/gbworkspace/web/cgi-src/htdb.c,v 1.40 2000/11/22 17:48:46 del Exp $"

/*
	Copyright  1994-2003 David Whittemore
	<del@adjective.com>, all rights reserved.

	Permission to use, copy, modify, and non-commercially distribute
	this software and its documentation for any purpose is hereby granted
	without fee, provided that the above copyright notice appear in all
	copies and that both that copyright notice and this permission notice
	appear in supporting documentation.  No representations are made about
	the suitability of this software for any purpose.  It is provided
	"as is" without express or implied warranty.
 */
#include	"htdb.h"

/*
	needLoginGateway()

		has it been awhile since this admin has passed through
		a login gateway?
 */
bool_t	needLoginGateway(void)
{
	return (!htdb_checkval("user->timeLastGatewayLogin") ||
		(htdb_checkval("user->timeLastGatewayLogin") &&
		(htdb_getint("_db_timestamp") - htdb_getint("user->timeLastGatewayLogin")) >
		htdb_getint("registry->gatewayLoginWindow"))) ? BOOL_TRUE : BOOL_FALSE;
}

/*
	updateLoginGateway()

		they just passed through a login gateway.
		reset the clock by squirreling the timestamp away in
		user->timeLastGatewayLogin
 */
void	updateLoginGateway(int_t user_id)
{
	storeUserData(user_id, "timeLastGatewayLogin", htdb_getval("_db_timestamp"));
}

bool_t	processUploadedPhoto(int_t user_id, int_t thing_id, char *dir, char *file, char *type, char *errorResource)
{
	bool_t status = BOOL_FALSE;

	if (dir && *dir && file && *file) {
		/*
			only scale it if we got shit to scale.
			note that for down-scalings after the initial, we do not
			use the original file, but use the most recently scaled
			file as it can be much faster if the original is very large.
			cute, huh?
		 */
		char	name[BUF_LIMIT_SMALL + 1];
		sprintf(name, "%s_%ld", type, thing_id);
		if (!imageScaleAndStore("image.folio", user_id, name, dir, file, 250, 0) ||
			!imageScaleAndStore("image.folio", user_id, name, dir, "250.jpg", 150, 150) ||
			!imageScaleAndStore("image.folio", user_id, name, dir, "150.jpg", 100, 100) ||
			!imageScaleAndStore("image.folio", user_id, name, dir, "100.jpg", 72, 72) ||
			!imageScaleAndStore("image.folio", user_id, name, dir, "72.jpg", 50, 50) ||
			!imageScaleAndStore("image.folio", user_id, name, dir, "50.jpg", 12, 12))
			status = BOOL_TRUE;
		/*
			remove traces of the upload directory and its contents
			(which is where our scaled working files are stored)
		 */
		removeDirectory(dir);
	}
	if (status == BOOL_TRUE) {
		int errCount = 0;
		setErrors(1, "imageProblems", 1, errorResource, &errCount);
		htdb_setval("error->image", "badFile");
	}
	return status;
}

void	updateUserData(int_t user_id, char *var)
{
	char	*lookup = htdb_getptrdyname("user", var);

	if (htdb_getint(lookup) == 0)
		dbInsert("insert into userdata set "
			"userdata_id=NULL, "
			"user_id=%ld, "
			"name='%s', "
			"value='%d', "
			"dtcreated=now()",
			user_id,
			var,
			1);
	else
		dbUpdate("update userdata set "
			"value='%ld' "
			"where user_id=%ld "
			"and name='%s'",
			htdb_getint(lookup) + 1,
			user_id,
			var);

	free(lookup);
}

bool_t	checkUserForm(int_t user_id)
{
	int errCount = 0;
	char *prefix = "";
	int	errors = 0,
		required = 0;
	bool_t	afterSubmit = htdb_checkval("submit") ? BOOL_TRUE : BOOL_FALSE;

	if (afterSubmit) {
		htdb_setval("afterSubmit", "yup");
		required = 1;
	} else {
		/*
			first time in the form populate data from user table
		 */
		prefix = "user";
	}
		
    errors |= setScreenName(prefix, "screenname", 1 & required, 1, "textErrorRegistrationScreennameMissing", &errCount);

    if (afterSubmit &&
		!htdb_checkval("error->screenname") &&
        dbGetRowByKey("chq",
			"select user_id from user where screenname = '%s' limit 1",
        htdb_getval("_form_1_screenname")) == 1 &&
        (user_id == 0 || (htdb_getint("chq->user_id") != user_id))) {
        /*
            screenname taken
         */
		errors |= setErrors(1, "screenname", 1, "textErrorRegistrationScreennameTaken", &errCount);
    }

	errors |= setYear(prefix, "birthyear", 1 & required, 1, "textErrorRegistrationBirthyearMissing", &errCount);

	errors |= setForm(prefix, "firstname", 1 & required, 1, "textErrorRegistrationFirstNameMissing", &errCount);	
	errors |= setForm(prefix, "lastname", 1 & required, 1, "textErrorRegistrationLastNameMissing", &errCount);	
	errors |= setForm(prefix, "city", 1 & required, 1, "textErrorRegistrationCityMissing", &errCount);	
	errors |= setForm(prefix, "address1", 1 & required, 1, "textErrorRegistrationAddress1Missing", &errCount);	
	errors |= setForm(prefix, "address2", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "phone1", 1 & required, 1, "textErrorRegistrationPhone1Missing", &errCount);	
	errors |= setForm(prefix, "phone1type", 1 & required, 1, "textErrorRegistrationPhone1TypeMissing", &errCount);	
	errors |= setForm(prefix, "phone2", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "phone2type", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "phone3", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "phone3type", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "phone4", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "phone4type", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "employer", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "occupation", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "referal", 0, 1, "", &errCount);	
	errors |= setIntOption(prefix, "state_id", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "statewritein", 0, 1, "", &errCount);	
	errors |= setIntOption(prefix, "country_id", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "countrywritein", 0, 1, "", &errCount);	
	errors |= setForm(prefix, "postalcode", 1 & required, 1, "textErrorRegistrationPostalCodeMissing", &errCount);	
	errors |= setForm(prefix, "phone", 0, 1, "", &errCount);	
    errors |= setRadio(prefix, "gender", BOOL_TRUE, 1, "textErrorRegistrationGenderMissing", &errCount);
    errors |= setCheckbox(prefix, "mailinglist", BOOL_FALSE, 1, "", &errCount);

    if (htdb_equal("_form_1_state_id", "1") &&
        !htdb_checkval("_form_1_statewritein")) {
		errors |= setErrors(1, "state_id", 1, "textErrorRegistrationStateMissing", &errCount);
    }
    if (htdb_equal("_form_1_country_id", "1") &&
        !htdb_checkval("_form_1_countrywritein")) {
		errors |= setErrors(1, "country_id", 1, "textErrorRegistrationCountryMissing", &errCount);
    }
    if (afterSubmit && user_id == 0 && strcasestr(htdb_getval("_form_1_email"), "@hawkinsprice.biz")) {
        errors |= setErrors(1, "email", 1, "textErrorRegistrationUsernameContainsDomain", &errCount);
    }

    if (!htdb_checkval("error->email")) {
        if (htdb_checkval("_form_1_email"))
            errors |= setEmail(prefix, "email", 1 & required, 1, "textErrorRegistrationUsernameTaken", &errCount);
        else
            errors |= setEmail(prefix, "email", 1 & required, 1, "textErrorRegistrationUsernameMissing", &errCount);
    }

    if (afterSubmit && !htdb_checkval("error->email") &&
        dbGetRowByKey("chq",
        "select user_id from user where email = '%s' "
        "limit 1",
        htdb_getval("_form_1_email")) == 1 &&
        (user_id == 0 || (htdb_getint("chq->user_id") != user_id))) {
        /*
            email taken
         */
		errors |= setErrors(1, "email", 1, "textErrorRegistrationUsernameTaken", &errCount);
    }

	errors |= setForm(prefix, "password", 1 & required, 1, "textErrorRegistrationPasswordMissing", &errCount);

    if (afterSubmit && htdb_equal("_form_1_screenname", htdb_getval("_form_1_password"))) {
        errors |= setErrors(1, "password", 1, "textErrorRegistrationUsernameSameAsPassword", &errCount);
	}

    if (afterSubmit && htdb_equal("_form_1_password", "password"))
        errors |= setErrors(1, "password", 1, "textErrorRegistrationStupidPassword", &errCount);

	if (afterSubmit) {
		if (errors)
			htdb_setval("anyErrors", "yup");
		else {
			if (user_id > 0) {
				/*
					this will be an update
				 */
				dbUpdate("update user set "
					"email='%s', "
					"password='%s', "
					"firstname='%s', "
					"lastname='%s', "
					"address1='%s', "
					"address2='%s', "
					"city='%s', "
					"state_id=%ld, "
					"statewritein='%s', "
					"postalcode='%s', "
					"country_id=%ld, "
					"countrywritein='%s', "
					"gender='%s', "
					"referal='%s', "
					"birthyear=%ld, "
					"phone1='%s', "
					"phone1type='%s', "
					"phone2='%s', "
					"phone2type='%s', "
					"phone3='%s', "
					"phone3type='%s', "
					"phone4='%s', "
					"phone4type='%s', "
					"employer='%s', "
					"occupation='%s', "
					"mailinglist='%s', "
					"dtcreated=now() "
					"where user_id=%ld",
					htdb_getval("_form_1_email"),
					htdb_getval("_form_1_password"),
					htdb_getval("_form_1_firstname"),
					htdb_getval("_form_1_lastname"),
					htdb_getval("_form_1_address1"),
					htdb_getval("_form_1_address2"),
					htdb_getval("_form_1_city"),
					htdb_getint("_form_1_state_id"),
					htdb_getval("_form_1_statewritein"),
					htdb_getval("_form_1_postalcode"),
					htdb_getint("_form_1_country_id"),
					htdb_getval("_form_1_countrywritein"),
					htdb_getval("_form_1_gender"),
					htdb_getval("_form_1_referal"),
					htdb_getint("_form_1_birthyear"),
					htdb_getval("_form_1_phone1"),
					htdb_getval("_form_1_phone1type"),
					htdb_getval("_form_1_phone2"),
					htdb_getval("_form_1_phone2type"),
					htdb_getval("_form_1_phone3"),
					htdb_getval("_form_1_phone3type"),
					htdb_getval("_form_1_phone4"),
					htdb_getval("_form_1_phone4type"),
					htdb_getval("_form_1_employer"),
					htdb_getval("_form_1_occupation"),
					htdb_getval("_form_1_mailinglist"),
					user_id);
			} else {
				/*
					this will be an account creation
				 */
				user_id = dbInsert("insert into user set "
					"user_id=NULL, "
					"email='%s', "
					"password='%s', "
					"firstname='%s', "
					"lastname='%s', "
					"address1='%s', "
					"address2='%s', "
					"city='%s', "
					"state_id=%ld, "
					"statewritein='%s', "
					"postalcode='%s', "
					"country_id=%ld, "
					"countrywritein='%s', "
					"screenname='%s', "
					"gender='%s', "
					"referal='%s', "
					"birthyear=%ld, "
					"phone1='%s', "
					"phone1type='%s', "
					"phone2='%s', "
					"phone2type='%s', "
					"phone3='%s', "
					"phone3type='%s', "
					"phone4='%s', "
					"phone4type='%s', "
					"employer='%s', "
					"occupation='%s', "
					"mailinglist='%s', "
					"dtcreated=now() ",
					htdb_getval("_form_1_email"),
					htdb_getval("_form_1_password"),
					htdb_getval("_form_1_firstname"),
					htdb_getval("_form_1_lastname"),
					htdb_getval("_form_1_address1"),
					htdb_getval("_form_1_address2"),
					htdb_getval("_form_1_city"),
					htdb_getint("_form_1_state_id"),
					htdb_getval("_form_1_statewritein"),
					htdb_getval("_form_1_postalcode"),
					htdb_getint("_form_1_country_id"),
					htdb_getval("_form_1_countrywritein"),
					htdb_getval("_form_1_screenname"),
					htdb_getval("_form_1_gender"),
					htdb_getval("_form_1_referal"),
					htdb_getint("_form_1_birthyear"),
					htdb_getval("_form_1_phone1"),
					htdb_getval("_form_1_phone1type"),
					htdb_getval("_form_1_phone2"),
					htdb_getval("_form_1_phone2type"),
					htdb_getval("_form_1_phone3"),
					htdb_getval("_form_1_phone3type"),
					htdb_getval("_form_1_phone4"),
					htdb_getval("_form_1_phone4type"),
					htdb_getval("_form_1_employer"),
					htdb_getval("_form_1_occupation"),
					htdb_getval("_form_1_mailinglist"));
				htdb_setint("inserted->user_id", user_id);
				htdb_setval("inserted->email", htdb_getval("_form_1_email"));
				htdb_setval("inserted->firstname", htdb_getval("_form_1_firstname"));
				htdb_include("macros");
				htdb_emailVerbage("emailSendConfirmation");
			}
		}
	}
	return (errors > 0) ? BOOL_FALSE : BOOL_TRUE;
}

void	handleSearch(char **resource, char **error_resource)
{
	*resource = "searchIndex";
}

void	handleRegister(char **resource, char **error_resource)
{
	if (htdb_equal("page", "paid.html")) {
		*resource = "registerRecorded";
	} else if (isConfirmed()) {
		if (dbGetRowByKey("_cl",
			"select * from class where class_id=%ld", htdb_getint("class_id"))) {
			/*
				are they already in this class?
			 */
			if (dbGetRowByKey("_uc",
				"select * from user_class where user_id=%ld and class_id=%ld",
				htdb_getint("user->user_id"),
				htdb_getint("class_id"))) {
				*resource = "registerRecordedAlready";
			} else {
				/*
					drop a new row into the user_class table
				 */
				dbInsert("insert into user_class set "
					"user_class_id=NULL, "
					"user_id=%ld, "
					"class_id=%ld, "
					"status='pending', "
					"amount=%s, "
					"method='none', "
					"dtcreated=now(), "
					"dtapproved=0, "
					"dtdeclined=0, "
					"isdeleted='F'",
					htdb_getint("user->user_id"),
					htdb_getint("_cl->class_id"),
					htdb_getval("_cl->price"));
				/*
					we'll do a redirect over to paypal at this point..
				 */
				htdb_httpRedirect("%s", htdb_getval("paypalPaymentURL"));
			}
		} else {
			*resource = "registerRecordedNoSuch";
		}
	} else {
		htdb_setval("textError", htdb_lookupVerbage("textErrorLoginToRegister"));
		*resource = "userLogin";
	}
}

bool_t	isEditor(void)
{
	return (htdb_defined("user->accountype->Editor") ? BOOL_TRUE : BOOL_FALSE);
}

char	*fetchBackto(void)
{
	char	*backto = htdb_getval("backto");
	if (backto && *backto && *backto == '|') {
		char	*ptr = htdb_decryptor(backto);
		htdb_setval("backto", htdb_decryptor(backto));
		free(ptr);
	}
	return htdb_getval("backto");
}

void	handleAdmin(char **resource, char **error_resource)
{
	if (isAdmin() || isEditor()) {
		if (htdb_equal("page", "users.html")) {
			if (isAdmin())
				*resource = "adminUsers";
			else {
				htdb_setval("textError", htdb_lookupVerbage("textErrorAdminPriviledges"));
				*resource = "userLogin";
			}
		} else if (htdb_equal("page", "verbage.html")) {

			if (htdb_defined("edit")) {
				/*
					edit existing
				 */
				if (htdb_getnum("verbage_id")) {
					dbUpdate("update verbage set "
						"isdeleted='%s', "
						"ishidden='%s', "
						"body='%s', "
						"summary='%s', "
						"name='%s', "
						"resource='%s' "
						"where verbage_id=%ld",
						(htdb_checkval("isdeleted") ? "T" : "F"),
						(htdb_checkval("ishidden") ? "T" : "F"),
						htdb_getval("body"),
						htdb_getval("summary"),
						htdb_getval("name"),
						htdb_getval("theresource"),
						htdb_getint("verbage_id"));
				} else {
					/*
						insert new
					 */
					dbInsert("insert into verbage set "
						"verbage_id=NULL, "
						"dtcreated=now(), "
						"isdeleted='%s', "
						"ishidden='%s', "
						"body='%s', "
						"summary='%s', "
						"name='%s', "
						"resource='%s'",
						(htdb_checkval("isdeleted") ? "T" : "F"),
						(htdb_checkval("ishidden") ? "T" : "F"),
						htdb_getval("body"),
						htdb_getval("summary"),
						htdb_getval("name"),
						htdb_getval("theresource"));
				}
				/*
					and re-fetch the changes
				 */
				dbGetRowByKey("verbage", "select * from verbage where isdeleted='F' order by name, resource");
			}
			*resource = "adminVerbage";
		} else if (htdb_equal("page", "news.html")) {

			if (htdb_defined("edit")) {
				/*
					edit existing
				 */
				if (htdb_getnum("news_id")) {
					dbUpdate("update news set "
						"isdeleted='%s', "
						"dtstop='%s-%s-%s', "
						"dtstart='%s-%s-%s', "
						"body='%s', "
						"teaser='%s', "
						"headline='%s', "
						"author='%s' "
						"where news_id=%ld",
						(htdb_checkval("isdeleted") ? "T" : "F"),
						htdb_getval("dtstop_year"),
						htdb_getval("dtstop_monthnum"),
						htdb_getval("dtstop_day"),
						htdb_getval("dtstart_year"),
						htdb_getval("dtstart_monthnum"),
						htdb_getval("dtstart_day"),
						htdb_getval("body"),
						htdb_getval("teaser"),
						htdb_getval("headline"),
						htdb_getval("author"),
						htdb_getint("news_id"));
				} else {
					/*
						insert new
					 */
					dbInsert("insert into news set "
						"news_id=NULL, "
						"dtcreated=now(), "
						"isdeleted='%s', "
						"dtstop='%s-%s-%s', "
						"dtstart='%s-%s-%s', "
						"body='%s', "
						"teaser='%s', "
						"headline='%s', "
						"author='%s'",
						(htdb_checkval("isdeleted") ? "T" : "F"),
						htdb_getval("dtstop_year"),
						htdb_getval("dtstop_monthnum"),
						htdb_getval("dtstop_day"),
						htdb_getval("dtstart_year"),
						htdb_getval("dtstart_monthnum"),
						htdb_getval("dtstart_day"),
						htdb_getval("body"),
						htdb_getval("teaser"),
						htdb_getval("headline"),
						htdb_getval("author"));
				}
				/*
					and re-fetch the changes
				 */
				dbGetRowByKey("news", "select * from news where isdeleted='F' order by dtcreated desc");
			}
			*resource = "adminNews";
		} else if (htdb_equal("page", "materials.html")) {
			*resource = "adminMaterials";
		} else if (htdb_equal("page", "images.html")) {
			*resource = "adminImages";
		} else if (htdb_equal("page", "pages.html")) {
			*resource = "adminPages";
		} else if (htdb_equal("page", "index.html")) {
			*resource = "adminIndex";
		} else {
			htdb_setval("textError", htdb_lookupVerbage("textErrorAdminPriviledges"));
			*resource = "userLogin";
		}
	} else {
		htdb_setval("textError", htdb_lookupVerbage("textErrorAdminPriviledges"));
		*resource = "userLogin";
	}
	if (htdb_checkval("edit") && htdb_checkval("backto")) {
		/*
			let's return them to where they came from before
			they started the edit
		 */
		htdb_httpRedirect("http://%s%s%s",
			"www.",
			htdb_getval("cgi->server_name"),
			fetchBackto());
	}
}

static bool_t	processConfirmation(char *in)
{
	bool_t	status = BOOL_TRUE;

	if (in && *in) {
		/*
			if we got something to work with
		 */
		if (dbGetRowByKey("user",
			"select * from user "
			"where email = '%s' and isdeleted = 'F' limit 1", in) == 1) {
			if (htdb_equal("user->isconfirmed", "F")) {
				int_t	id = htdb_getint("user->user_id");
				/*
					if it looked-up ok as an undeleted, unconfirmed email
					then update this account to type "fan"
				 */
				if (dbUpdate("update user set isconfirmed='%s' where user_id = %ld",
					"T",	/* isconfirmed */
					id)) {
					status = BOOL_TRUE;
				}
				/* 
				   	and set the status for later cgi stuff
				*/
				htdb_setval("user->isconfirmed", "T");

			} else if (htdb_equal("user->isconfirmed", "T")) {
				status = BOOL_TRUE;
			} else {
				status = BOOL_FALSE;
			}
		} else
			status = BOOL_FALSE;
	} else
		status = BOOL_FALSE;

	if (BOOL_FALSE == status) {
		/*
			this bit manually logs them out so that we can force a login.
			this brute-force security measure ensures that confirmation emails
			cannot be passed around to assume others' identities..
		 */
		dbUpdate("update session set user_id = %ld where session_id = %ld",
			0L, htdb_getint("_session_int"));
		/*
			HTMLland navigation needs this to be updated.
		 */
		htdb_setval("user->authenticated", "nope");
		htdb_setval("user->isconfirmed", "F");
	} else
		dbUpdate("update session set user_id = %ld where session_id = %ld",
			htdb_getint("user->user_id"), htdb_getint("_session_int"));

	return status;
}

bool_t	processPassword(int_t user_id)
{
	htdb_setval("textError", "");

	if (htdb_defined("email")) {
		char	*email = htdb_getval("email");
		/*
			after the submit
		 */
		if (isUser()) {
			/*
				user is logged-in - probably an unconfirmed account
			 */
			if (htdb_equal("user->email", email)) {
				/*
					same email - just send the password
				 */
			} else {
				/*
					different email - change it if appropriate
				 */
				if (isValidEmailAddress(email)) {
					dbUpdate("update user set email='%s' where user_id=%ld", email, user_id);
				} else {
					htdb_setval("textError", htdb_lookupVerbage("textErrorSendPasswordInvalidEmail"));
					return BOOL_FALSE;
				}
			}
		} else {
			/*
				logged-out - just do a lookup
			 */
		}
		if (dbGetRowByKey("forgetful",
			"select firstname, email, password from user where email='%s'", email) == 0) {
			htdb_setval("textError", htdb_lookupVerbage("textErrorSendPasswordNotFound"));
			return BOOL_FALSE;
		}
		htdb_emailVerbage("emailSendPassword");
		return BOOL_TRUE;
	} else {
		/*
			first time in
		 */
		return BOOL_FALSE;
	}
}

void	handleUser(char **resource, char **error_resource)
{
	int_t	user_id = htdb_getint("user->user_id");

	if (htdb_equal("page", "password.html")) {
		if (processPassword(user_id)) {
			*resource = "userPasswordSuccess";
		} else {
			*resource = "userPassword";
		}
	} else if (htdb_equal("page", "account.html")) {
		if (checkUserForm(user_id)) {
			/*
				things worked ok..
			 */
			if (user_id > 0) {
				if (htdb_checkval("afterSubmit")) {
					/*
						this was a successful user edit
					 */
					htdb_setval("textSuccess", htdb_lookupVerbage("textSuccessAccountUpdated"));
					*resource = "userIndex";
				} else
					/*
						show the edit form
					 */
					*resource = "userAccount";
			} else {
				/*
					this was a successful user creation
				 */
				*resource = "userConfirmationSent";
			}
		} else
			/*
				first time in, or there were problems
			 */
			*resource = "userAccount";
		} else if (htdb_equal("page", "reconfirmation.html")) {
			htdb_setint("inserted->user_id", htdb_getint("user->user_id"));
			htdb_setval("inserted->email", htdb_getval("user->email"));
			htdb_setval("inserted->firstname", htdb_getval("user->firstname"));
			htdb_include("macros");
			htdb_emailVerbage("emailSendConfirmation");
			*resource = "userConfirmationSent";
	 } else if (htdb_equal("page", "confirmation.html")) {
		if (BOOL_TRUE == processConfirmation(htdb_getval("inserted_email"))) {
			htdb_setval("textSuccess", htdb_lookupVerbage("textSuccessAfterConfirmation"));
			if (htdb_checkval("backto"))
				/*
					let's return them to where they came from before
					they started the account sign-up
				 */
				htdb_httpRedirect("http://%s%s%s",
					"www.",
					htdb_getval("cgi->server_name"),
					fetchBackto());
			else
				*resource = "userIndex";
		} else
			*resource = "userIndex";
	} else {
		*resource = "userIndex";
	}
}

void	doMain(void)
{
	char	*resource = "",
			*error_resource = "";

	/*
		what's the virtual CGI?
	 */
	if (htdb_equal("cgi->script_name", "/user"))
		handleUser(&resource, &error_resource);
	else if (htdb_equal("cgi->script_name", "/search"))
		handleSearch(&resource, &error_resource);
	else if (htdb_equal("cgi->script_name", "/admin"))
		handleAdmin(&resource, &error_resource);
	else if (htdb_equal("cgi->script_name", "/register"))
		handleRegister(&resource, &error_resource);

	if (htdb_checkval("pg"))
		resource = htdb_getval("pg");

	/*
		is it appropriate to show errors on forms?
	 */
	if (!htdb_equal("afterSubmit", "yup")) {
		spaceData	*b;
		htdb_initwalk();
		while ((b = htdb_walkspace())) {
			if (strncmp(b->key, "error->", 7) == 0) {
				free(b->value);
				b->value = strdup("");
			}
			if (strncmp(b->key, "error[", 6) == 0) {
				free(b->value);
				b->value = strdup("");
			}
		}
	}

	/*
		if we have a resource to display, then log the fact
		and display the resource.  if there is no value for `resource',
		then it is assumed that the CGI handler has taken care
		of everything already..
	 */
	if (resource && *resource) {

		/*
			everything and his brother uses the value of `pageResource'
			to denote the "starting point" for the page to be generated.
		 */
		htdb_setval("pageResource", resource);

		{
			char	lookup[PATH_MAX + 1];

			/*
				finish stuff up by reading the macros resource file.
				this will pull in all the session-specific stuff that
				needs to be evaluated.
			 */
			htdb_include("macros");
			/*
				read in the appropriate resource file based upon
				the defined value of `resource' as set by the cgi
				handler function above.
			 */
			snprintf(lookup, PATH_MAX, "_%s", resource);
			htdb_include(lookup);
		}

		if (htdb_checkval(resource)) {
			/*
				and guess what?
				we're finally going to show the friggin page!
			 */
			htdb_doHeader(CONTENT_TYPE_TEXT_HTML);
			htdb_print(htdb_getval(resource));
			htdb_doFooter(CONTENT_TYPE_TEXT_HTML);
			htdb_log(resource, htdb_getval("logValue"));
		} else {
			/*
				there's no page data associated with the
				given resource found in the environment.
				give some usage hints - by redirecting on over
				to the master doc website.
			 */
			htdb_httpRedirect("http://www.htdb.org/htdb/errno/103.html?dr=%s&res=%s",
				htdb_getval("cgi->document_root"),
				resource);
		}
	} else {
		/*
			we hit this block if an http redirect has been handled already -
			in which case the resource value is not set.
			that, or the programmer fucked up and didn't set
			the resource value in the handler.
		 */
	}
}

appinfo_t	appinfo = {
	"uber",
	"0.0.2",
	"i'm the uber CGI - i do most everything if called with the proper arguments",
	"",
	doMain,
	FCGI_KEEPALIVE
};

int main(int argc, char **argv)
{
	exit (htdb_main(argc, argv, &appinfo));
}
